define<export>{
	LIBC_PATH = "/lib/libc.so"
}

import $LIBC_PATH <cdeclare>
{
	//uint syscall(uint num, uint a, uint b,uint c,uint d,)
	//int syscall(int /*sysnum*/, int /*a*/, int /*b*/, int /*c*/, int /*d*/, int /*e*/, int /*f*/)
	int tolower(int)
	int toupper(int)
	uint strftime(uint,uint,uint,uint) ->lu_strftime
	uint localtime_r(uint,uint) ->lu_localtime_r
	uint strcpy(uint,uint)
	uint strlen(uint)
	uint strcat(uint,uint)
	int putchar(int /*c*/)
	int puts(uint )
	int syscall3(int /*syscall*/, int /*arg1*/, int /*arg2*/, int /*arg3*/)
	int syscall2(int /*syscall*/, int /*arg1*/, int /*arg2*/)
	int syscall1(int /*syscall*/, int /*arg1*/)
	int	 read( int /*fid*/, uint /*buffer*/, uint /*size*/)
	int write(int /*fid*/, uint /*buffer*/, uint /*size*/ )
	int	 open( uint /*filename*/, int /*flags*/, uint /*mode*/)
	int close( int /*fid*/)
	uint lseek( int /*a*/, uint /*b*/, int /*c*/)
	int waitpid( uint /*pid*/, uint /*status*/, int /*options*/)
	int creat( uint /*pathname*/, int /*mode*/)
	execve( uint /*a*/, uint /*b*/, uint /*c*/)
	int chdir ( uint /*destpath*/)
	int time( uint /*time_ptr*/ )
	//int _chmod( uint /*a*/, uint /*b*/)

	int rename( uint /*oldpath*/, uint /*newpath*/)
	int mkdir( uint /*path*/, uint /*mode*/ )
	int rmdir( uint /*path*/)
	int gettimeofday( uint /*a*/, uint /*b*/)
	int settimeofday( uint /*a*/, uint /*b*/)
	uint stat( uint /*path*/, uint /*stat_ptr*/)
	uint lstat( uint /*path*/, uint /*stat_ptr*/ )
	uint fstat( int /*fd*/, uint /*stat_ptr*/ )
	uint getcwd( uint /*dest*/, uint /*dest_size*/)

}

func int syscall0(int no){
	return	syscall1(no,0);
}

func draw_window(){
	str s;
	syscall1(12,1);
	syscall3(0,10*65536 + 150, 40*65536 + 50,0x33FFFFFF);
	s="Hello World!";
	syscall3(4,30*65536 + 10,0x80000000, s.ptr());
	syscall1(12,2);

}
func main_cicle(){
	int event,key;
	draw_window();
	syscall1(40,7|16);//set event mask
	print("\ntry cicle key=\(key)");
	while(1){
		print("\ntry get event");
		event=syscall1(10,0);
		//event=syscall0(10);
		print("\nevent:");
		print("\(event)");
		switch(event){

		case 0
		{
			continue;
			//draw_window();
		}

		case 1,5
		{
			draw_window();
		}

		case 2
		{
		      key=syscall0(2);
		       print("\nkey pressed:\(key)");
		 }

		case 3
		 {
		       //syscall0(2);
		       return;
		 }
		 }//switch

	};
}

func main <main> () {
	print("\ntry putchar func:\n");
	print("\nok putchar func:\n");
	//main_cicle();
	str s="\nby write:Hello World!";
	puts("\nby puts:Hello World!".ptr());
	write(1,s.ptr(),*s);
	print ("ok quit") ;
	main_cicle();
	syscall0(-1);
	print("\nError! After _exit():") ;
}