define<export>{
	LIBC_PATH = "/lib/libc.so"
}

import $LIBC_PATH <cdeclare>
{
	//uint syscall(uint num, uint a, uint b,uint c,uint d,)
	//int syscall(int /*sysnum*/, int /*a*/, int /*b*/, int /*c*/, int /*d*/, int /*e*/, int /*f*/)
	int tolower(int)
	int toupper(int)
	uint strftime(uint,uint,uint,uint) ->lu_strftime
	uint localtime_r(uint,uint) ->lu_localtime_r
	uint strcpy(uint,uint)
	uint strlen(uint)
	uint strcat(uint,uint)
	int putchar(int /*c*/)
	int puts(uint )
	int syscall3(int /*syscall*/, int /*arg1*/, int /*arg2*/, int /*arg3*/)
	int syscall2(int /*syscall*/, int /*arg1*/, int /*arg2*/)
	int syscall1(int /*syscall*/, int /*arg1*/)
	int	 read( int /*fid*/, uint /*buffer*/, uint /*size*/)
	int write(int /*fid*/, uint /*buffer*/, uint /*size*/ )
	int	 open( uint /*filename*/, int /*flags*/, uint /*mode*/)
	int close( int /*fid*/)
	uint lseek( int /*a*/, uint /*b*/, int /*c*/)
	int waitpid( uint /*pid*/, uint /*status*/, int /*options*/)
	int creat( uint /*pathname*/, int /*mode*/)
	execve( uint /*a*/, uint /*b*/, uint /*c*/)
	int chdir ( uint /*destpath*/)
	int time( uint /*time_ptr*/ )
	//int _chmod( uint /*a*/, uint /*b*/)

	int rename( uint /*oldpath*/, uint /*newpath*/)
	int mkdir( uint /*path*/, uint /*mode*/ )
	int rmdir( uint /*path*/)
	int gettimeofday( uint /*a*/, uint /*b*/)
	int settimeofday( uint /*a*/, uint /*b*/)
	uint stat( uint /*path*/, uint /*stat_ptr*/)
	uint lstat( uint /*path*/, uint /*stat_ptr*/ )
	uint fstat( int /*fd*/, uint /*stat_ptr*/ )
	uint getcwd( uint /*dest*/, uint /*dest_size*/)

}

define <export>{
	MAXERR	    = 4000
	UMASK			= 0x1c0
	O_ACCMODE	= 0x003
	O_RDONLY	   = 0x000
	O_WRONLY	   = 0x001
	O_RDWR		= 0x002
	O_CREAT 	= 0x040
	O_EXCL		= 0x080
	O_NOCTTY	   = 0x100
	O_TRUNC 	= 0x200
	O_APPEND		= 0x400
	O_NONBLOCK	= 0x020
	O_NDELAY		= 0x020
	O_SYNC		= 0x1000
	O_FSYNC 	= 0x1000
	O_ASYNC 	= 0x2000
	LOCK_SH 	= 0x01
	LOCK_EX 	= 0x02
	LOCK_UN 	= 0x08
	TRUE = 1
	FALSE = 0
	FILE_BEGIN = 0
	FILE_CURRENT = 1
	FILE_END = 2
}


func int syscall0(int no){
	return	syscall1(no,0);
}

func draw_window(){
	str s;

	syscall1(12,1);
	syscall3(0,10*65536 + 150, 40*65536 + 50,0x33FFFFFF);
	s="Hello World!";
	syscall3(4,30*65536 + 10,0x80000000, s.ptr());
	syscall1(12,2);

}
func main_cicle(){
	int event,key;
	draw_window();
	syscall1(40,7);//set event mask
	print("\n try cicle key=\(key)");
	while(1){
		print("\ntry get event");
		event=syscall1(10,0);
		//event=syscall0(10);
		print("\nevent:\n");
		print("\(event)");
		if (event==0){
			continue;
			//draw_window();
		}
		if (event==1){
			draw_window();
			continue;
		}
		if (event==2){
		      key=syscall0(2);
		       print("\nkey pressed:\(key)");
		      continue;
		 }
		 if (event==3){
		       //syscall0(2);
		       return;
		 }

	};
}

func test_libc <main> () {
	print("\ntry putchar func:\n");
	putchar('H');
	putchar('e');
	putchar('l');
	putchar('l');
	putchar('o');
	print("\nok putchar func:\n");
	//main_cicle();
	str s="\nby write:Hello World!";
	puts("\nby puts:Hello World!".ptr());
	write(1,s.ptr(),*s);
	print ("ok quit") ;
	main_cicle();
	syscall0(-1);
	print("\nError! After _exit():") ;

}