define<export>{
	LIBC_PATH = "/lib/libc.so"
}

import $LIBC_PATH <cdeclare>
{
	//uint syscall(uint num, uint a, uint b,uint c,uint d,)
	//int syscall(int /*sysnum*/, int /*a*/, int /*b*/, int /*c*/, int /*d*/, int /*e*/, int /*f*/)
	int tolower(int)
	int toupper(int)
	exit(int)
	uint strftime(uint,uint,uint,uint) ->lu_strftime
	uint localtime_r(uint,uint) ->lu_localtime_r
	uint strcpy(uint,uint)
	uint strlen(uint)
	uint strcat(uint,uint)
	int putchar(int /*c*/)
	int puts(uint )
	int syscall3(int /*syscall*/, int /*arg1*/, int /*arg2*/, int /*arg3*/)
	int syscall2(int /*syscall*/, int /*arg1*/, int /*arg2*/)
	int syscall1(int /*syscall*/, int /*arg1*/)
	int	 read( int /*fid*/, uint /*buffer*/, uint /*size*/)
	int write(int /*fid*/, uint /*buffer*/, uint /*size*/ )
	int	 open( uint /*filename*/, int /*flags*/, uint /*mode*/)
	int close( int /*fid*/)
	uint lseek( int /*a*/, uint /*b*/, int /*c*/)
	int waitpid( uint /*pid*/, uint /*status*/, int /*options*/)
	int creat( uint /*pathname*/, int /*mode*/)
	execve( uint /*a*/, uint /*b*/, uint /*c*/)
	int chdir ( uint /*destpath*/)
	int time( uint /*time_ptr*/ )
	//int _chmod( uint /*a*/, uint /*b*/)

	int rename( uint /*oldpath*/, uint /*newpath*/)
	int mkdir( uint /*path*/, uint /*mode*/ )
	int rmdir( uint /*path*/)
	int gettimeofday( uint /*a*/, uint /*b*/)
	int settimeofday( uint /*a*/, uint /*b*/)
	uint stat( uint /*path*/, uint /*stat_ptr*/)
	uint lstat( uint /*path*/, uint /*stat_ptr*/ )
	uint fstat( int /*fd*/, uint /*stat_ptr*/ )
	uint getcwd( uint /*dest*/, uint /*dest_size*/)
	uint dlopen(uint,int)
	uint dlsym(uint,uint)

}
import "/sys/lib/console.obj"{
	con_init(int,int,int,int,uint)
	con_set_title(uint)
	con_write_asciiz(uint)
}

import "/kolibrios/lib/libc.dll" <cdeclare>
{
	puts(uint) -> c_puts
}




func int syscall0(int no){
	return	syscall1(no,0);
}


func test_console(){
	//con_init(-1,-1,-1,-1,"Hello title!".ptr());
	con_write_asciiz("\nHello by import con_write_asciiz".ptr())

}

func int test_libc <main> () {
	print("\ntry putchar func:\n");
	print("\nok putchar func:\n");
	//main_cicle();
	puts("\nHello World!".ptr());
	print ("ok quit") ;
	// main_cicle();
	test_console();
	print("\nok quit test console");
	c_puts("\nStr by puts!".ptr());
	//return 0;
	exit(0);
	syscall0(-1);
	print("\nError! After _exit():") ;
	return 0;
}